/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.view.component
 * File:    NavigationPanel.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.view.component;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import javax.swing.ListSelectionModel;
import javax.swing.border.MatteBorder;

import de.fhhannover.inform.ifmap.view.navigation.TreePanel;

public class NavigationPanel extends JPanel {
	private static final long serialVersionUID = 4248002471880371362L;
	public JToggleButton buttonConnections;
	public JToggleButton buttonTree;
	public JList panelList;
	public TreePanel panelTree;
	private final ButtonGroup buttonGroup = new ButtonGroup();

	public NavigationPanel() {
		setPreferredSize(new Dimension(151, 433));
		setLayout(new BorderLayout(0, 0));		
		
		JPanel panelTop = new JPanel();
		panelTop.setBorder(null);
		FlowLayout flowLayout = (FlowLayout) panelTop.getLayout();
		flowLayout.setAlignment(FlowLayout.LEFT);
		add(panelTop, BorderLayout.NORTH);
		
		buttonConnections = new JToggleButton();
		buttonConnections.setFocusable(false);
		buttonConnections.setSelected(true);
		buttonGroup.add(buttonConnections);
		buttonConnections.setPreferredSize(new Dimension(32, 32));
		buttonConnections.setIcon(new ImageIcon(getClass().getClassLoader().getResource("server_client.png")));
		panelTop.add(buttonConnections);
		
		buttonTree = new JToggleButton();
		buttonTree.setFocusable(false);
		buttonGroup.add(buttonTree);
		buttonTree.setPreferredSize(new Dimension(32, 32));
		buttonTree.setIcon(new ImageIcon(getClass().getClassLoader().getResource("content-tree.png")));
		panelTop.add(buttonTree);
		
		panelList = new JList();
		panelList.setModel(new DefaultListModel());
		panelList.setCellRenderer(new ConnectionListRenderer());
		panelList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		panelList.setBorder(new MatteBorder(1, 1, 1, 1, (Color) new Color(0, 0, 0)));		
		add(panelList, BorderLayout.CENTER);
		
		panelTree = new TreePanel();
	}
}
