/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.view.subscription
 * File:    QuickSubscribeIdentity.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.view.subscription;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class QuickSubscribeIdentity extends JPanel {
	private static final long serialVersionUID = 7669707523341935526L;
	public JTextField textFieldValue;
	public JTextField textFieldDomain;
	public QuickComboBox comboBoxKey;

	/**
	 * Create the panel.
	 */
	public QuickSubscribeIdentity() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{15, 0, 155, 0, 0};
		gridBagLayout.rowHeights = new int[]{5, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 1.0, 1.0, 0.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		
		comboBoxKey = new QuickComboBox();
		ComboBoxModel jComboBox1Model = 
			new DefaultComboBoxModel(
					new String[] { "aik-name", "distinguished-name", "dns-name",
							"email-address", "kerberos-principal", "username",
							"sip-uri", "tel-uri", "hip-tip", "other" });						
		jComboBox1Model.setSelectedItem("aik-name");
		comboBoxKey.setModel(jComboBox1Model);
		
		GridBagConstraints gbc_comboBoxKey = new GridBagConstraints();
		gbc_comboBoxKey.insets = new Insets(0, 0, 5, 5);
		gbc_comboBoxKey.anchor = GridBagConstraints.WEST;
		gbc_comboBoxKey.gridx = 1;
		gbc_comboBoxKey.gridy = 1;
		add(comboBoxKey, gbc_comboBoxKey);
		
		textFieldValue = new JTextField();
		GridBagConstraints gbc_textFieldValue = new GridBagConstraints();
		gbc_textFieldValue.insets = new Insets(0, 0, 5, 5);
		gbc_textFieldValue.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldValue.gridx = 2;
		gbc_textFieldValue.gridy = 1;
		add(textFieldValue, gbc_textFieldValue);
		textFieldValue.setColumns(10);
		
		JLabel lblAdministrativedomain = new JLabel("administrative-domain");
		GridBagConstraints gbc_lblAdministrativedomain = new GridBagConstraints();
		gbc_lblAdministrativedomain.anchor = GridBagConstraints.EAST;
		gbc_lblAdministrativedomain.insets = new Insets(0, 0, 5, 5);
		gbc_lblAdministrativedomain.gridx = 1;
		gbc_lblAdministrativedomain.gridy = 2;
		add(lblAdministrativedomain, gbc_lblAdministrativedomain);
		
		textFieldDomain = new JTextField();
		GridBagConstraints gbc_textFieldDomain = new GridBagConstraints();
		gbc_textFieldDomain.insets = new Insets(0, 0, 5, 5);
		gbc_textFieldDomain.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldDomain.gridx = 2;
		gbc_textFieldDomain.gridy = 2;
		add(textFieldDomain, gbc_textFieldDomain);
		textFieldDomain.setColumns(10);
		
		JButton btnSubscribe = new JButton("Subscribe");
		GridBagConstraints gbc_btnSubscribe = new GridBagConstraints();
		gbc_btnSubscribe.anchor = GridBagConstraints.EAST;
		gbc_btnSubscribe.insets = new Insets(0, 0, 5, 5);
		gbc_btnSubscribe.gridx = 2;
		gbc_btnSubscribe.gridy = 3;
		add(btnSubscribe, gbc_btnSubscribe);

	}

}
